PImage linksprite, bg, star, banana, start; // all of the images
PImage[][] sprites;
PFont mario, score;
int direction = 1;
int step = 0;
int x, y;
int r1, r2;
int speed = 4;
int gamemode = 0; // for the diff screens
int pts = 0; // points in game
import processing.sound.*;
SoundFile file;
String audioName = "music.wav";
float timer=0;
boolean timerActivated = false;


Banana[] bananas;
Star[] stars;
// arrays for both objects

void setup() {
  size (1000, 700);
  //loading the images and fonts here :
  bg     = loadImage("bg.png");
  star   = loadImage("star.png");
  banana = loadImage("banana.png");
  start  = loadImage("start.png");
  mario  = createFont("/Users/fatimaaljneibi/Library/Fonts/Mario-Kart-DS.ttf", 32);
  score  = createFont("Courier New", 25);
  linksprite = loadImage("linksprite.png");

  //theme music loop:
  file = new SoundFile(this, "music.wav");
  file.loop();


  stars = new Star[20] ;
  for (int i=0; i<stars.length; i++) {
    stars[i]= new Star(random(width), random(height));
  }

  bananas = new Banana[10] ;
  for (int i=0; i<bananas.length; i++) {
    bananas[i]= new Banana(random(width), random(height), random(-5, 5), random(-5, 5));
  }

  sprites = new PImage[4][10]; // 12 images across, 4 down, in the spritesheet

  int w = linksprite.width/10;
  int h = linksprite.height/4;

  for (int y=0; y < 4; y++) {
    for (int x=0; x< 10; x++) {
      sprites[y][x] = linksprite.get(x*w, y*h, w, h);
    }
  }

  x = width/2;
  y = height/2;

  imageMode(CENTER);
  textAlign(CENTER);
}

void draw() {

  if (gamemode == 0) { // starting screen
    background(start);
    fill(#5F9AEA);
    textFont(mario, 100);
    text("PIXEL RUN!", width/2, height/2-25);
    // instructions
    textFont(mario, 40);
    text("-press the space key to start-", width/2, height-300);
    textFont(mario, 25);
    fill(#3F7CC9);
    text("use arrow keys to move", width/2, height-200);
    text("collect the stars but avoid the bananas!!", width/2, height-150);
    text("score 500 points to win!", width/2, height-100);


    if (keyPressed) {
      if (key == ' ' ) {
        gamemode = 1;
        pts = 0;
      }
    }
  } else if (gamemode == 1) { // actual game code goes here

    background(bg);

    // makes the disappeared objects reappear every 5 seconds:
    if (timerActivated==true) {
      if (millis()>timer ) {
        println("timer done!");
        timerActivated = false;
        for (int i=0; i<15; i++) {
          if (stars[i].disp == false) {
            stars[i].starx = random(width);
            stars[i].stary = random(height);
          }
          stars[i]. disp=true;
        }
        for (int i=0; i<8; i++) {
          bananas[i]. disp=true;
        }
      }
    }


    if (timerActivated == false && gamemode == 1) {
      println("timer triggered");
      timer = millis()+5000; // more objects appear on screen every 5 seconds
      timerActivated = true;
    }


    // displays the initial stars & bananas, calls the functions from their classes
    for (int i=0; i<20; i++) {
      stars[i]. display();
    }
    for (int i=0; i<10; i++) {
      bananas[i]. display();
      bananas[i]. move();
    }


    //look at sprite sheet to determine which direction is which
    if (keyPressed) {
      if (keyCode == DOWN) {
        direction = 0;
        y+=speed;
      }
      if (keyCode == LEFT) {
        direction = 1;
        x-=speed;
      }
      if (keyCode == RIGHT) {
        direction = 3;
        x+=speed;
      }
      if (keyCode == UP) {
        direction = 2;
        y-=speed;
      }
      if (key == 'b' || key == 'B' ) {
        gamemode = 0;
      }
      if (keyCode == DOWN || keyCode ==  UP || keyCode == LEFT || keyCode == RIGHT) {

        if (frameCount%speed==0) { //the spritesheet images will loop only if the arrow keys are pressed
          step = (step+1) % 10;
        }
      }
    }

    image(sprites[direction][step], x, y); // the sprite


    // points system:
    for (int i=0; i<10; i++) {
      float d2 = dist(x, y, bananas[i].banx, bananas[i].bany);
      if ( d2 <= 50 && bananas[i].disp==true) {
        if (pts >=10)
          pts-= 10;
        // takes 10 points off for every banana collided w the sprite

        bananas[i].disp=false; //banana disappears
      }
    }

    for (int i=0; i<20; i++) {
      float d1 = dist(x, y, stars[i].starx, stars[i].stary);
      if ( d1 <= 50 && stars[i].disp==true) {
        pts+= 20;
        stars[i].disp=false;  //adds 20 pts per star and makes it disappear on contact w sprite
      }
    }





    if (y>height) {
      y=0;
    }
    if (y<0) {
      y=height;
    }
    if (x>width) {
      x=0;
    }
    if (x<0) {
      x=width;
    } // this is to keep the sprite always on screen

    //the score board:
    textFont(score);

    pushStyle();
    fill(255, 200);
    noStroke();
    rectMode(CENTER);
    rect(width-80, 22, textWidth("Score:" + pts)+10, 30);
    popStyle();
    fill(0);
    text("Score:" + pts, width-80, 30);
    pushStyle();
    fill(255, 180);
    noStroke();
    rect(2, height-20, 270, 15 );
    textAlign(LEFT);
    textFont(score, 15);
    fill(0);
    text("press 'b' to go back to start!", 2, height-8);
    popStyle();


    if (pts >= 500) {
      gamemode = 3;  //game ends when the player hits 500 pts
    }
  } // game code ends here

  if (gamemode == 3) {
    background(start);
    fill(#5F9AEA);
    textFont(mario, 100);
    text("YOU WIN!", width/2, height/2);

    textFont(mario, 50);
    text("Click space to play again!", width/2, height-300);
    if (keyPressed) {
      if (key == ' ' ) {
        gamemode = 1;
        x = width/2;
        y = height/2;
        direction = 0;
        pts = 0;
      }
    }
  } // win screen code ends here
}
